grammar TreeAndLexerRules;

// tree is a reserved word in antrl3, a parser rule with that name is confusing antlr4

mytree : classicTree | fTree ;
eq_s: classicTree '=' classicTree | fTree '=' fTree ;

classicTree: treeLeaf | treeNode ;
treeLeaf   : BEZ ; 
treeNode   : BEZ '(' classicTree (',' classicTree)*  ')' ;

fTree : fTreeBracketFree fTree | treeBracket | treeBez ;
fTreeBracketFree : fTreeBracketFree fTree | treeBez ;
treeBracket  : '(' fTree ')' ;
treeBez : BEZ ;

/*
 * Lexer Rules
 */

BEZ       : ([a-z] | [A-Z]) ([a-z] | [A-Z] | [0-9] | '_')* ;

NAT       : '0' | ([1-9] [0-9]*) ;

WHITESPACE: (' ' | '\t')        -> skip ;

NEWLINE   : ('\r'? '\n' | '\r') -> skip ;