﻿using System.Collections.Generic;

namespace Eingabeverwaltung.Metamodell
{
	public class TreeVariable : Tree
	{
		public readonly Variable variable;

		public TreeVariable(Variable variable) : base(variable.name, variable.sort) 
		{
			this.variable = variable;
		}
				
		public override string ToString() => variable.Name();

        public override List<Tree> findSubTree(Tree tree)
        {
			List<Tree> result = new List<Tree>();
			if (tree as TreeVariable != null && ((TreeVariable)tree).variable == variable)
			{
				result.Add(this);
			}
			return result;
        }
		public override List<Variable> findUsedVars() => new List<Variable>() { variable };

        public override bool Equals(Tree tree) => findSubTree(tree).Count > 0;

        public override Tree Copy() => new TreeVariable(variable);
    }
}
